package com.glxp.mipsdl.client.lhzyy;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.glxp.mipsdl.client.CommonHttpClient;
import com.glxp.mipsdl.config.ThirdSysConfig;
import com.glxp.mipsdl.constant.ConstantType;
import com.glxp.mipsdl.constant.Constants;
import com.glxp.mipsdl.dao.auth.AuthWarehouseDao;
import com.glxp.mipsdl.dao.basic.BasicBussinessTypeDao;
import com.glxp.mipsdl.dao.basic.BasicCorpDao;
import com.glxp.mipsdl.dao.basic.BasicUdirelDao;
import com.glxp.mipsdl.dao.inout.IoCodeDao;
import com.glxp.mipsdl.dao.inout.IoOrderDao;
import com.glxp.mipsdl.dao.inout.IoOrderDetailBizDao;
import com.glxp.mipsdl.dao.thrsys.ThrBustypeOriginDao;
import com.glxp.mipsdl.dao.thrsys.ThrInvWarehouseDao;
import com.glxp.mipsdl.dao.thrsys.ThrProductsDao;
import com.glxp.mipsdl.dao.thrsys.ThrSystemBusApiDao;
import com.glxp.mipsdl.entity.auth.AuthWarehouseEntity;
import com.glxp.mipsdl.entity.basic.BasicBussinessTypeEntity;
import com.glxp.mipsdl.entity.basic.BasicCorpEntity;
import com.glxp.mipsdl.entity.basic.BasicUdirelEntity;
import com.glxp.mipsdl.entity.lhsyy.MaterialDictEntity;
import com.glxp.mipsdl.entity.inout.IoCodeEntity;
import com.glxp.mipsdl.entity.inout.IoOrderDetailBizEntity;
import com.glxp.mipsdl.entity.inout.IoOrderEntity;
import com.glxp.mipsdl.entity.inout.IoOrderInvoiceEntity;
import com.glxp.mipsdl.entity.thrsys.ThrCorpEntity;
import com.glxp.mipsdl.entity.thrsys.ThrInvWarehouseEntity;
import com.glxp.mipsdl.entity.thrsys.ThrProductsEntity;
import com.glxp.mipsdl.entity.thrsys.ThrSystemBusApiEntity;
import com.glxp.mipsdl.http.HttpClient;
import com.glxp.mipsdl.req.base.*;
import com.glxp.mipsdl.req.ctqyy.CtqyyRequest;
import com.glxp.mipsdl.req.dsxyy.DsOrderRequest;
import com.glxp.mipsdl.req.lhzyy.LhProductRequest;
import com.glxp.mipsdl.req.lhzyy.LhUnitRequest;
import com.glxp.mipsdl.req.lhzyy.LhzyyRequest;
import com.glxp.mipsdl.req.post.*;
import com.glxp.mipsdl.req.yxzyy.YxBusTypeRequest;
import com.glxp.mipsdl.req.yxzyy.YxProductRequest;
import com.glxp.mipsdl.req.yxzyy.YxUnitRequest;
import com.glxp.mipsdl.res.BaseResponse;
import com.glxp.mipsdl.res.Lhzyy.LhBaseResponse;
import com.glxp.mipsdl.res.ctqyy.CtBaseResponse;
import com.glxp.mipsdl.res.udiwms.UdiRelevanceResponse;
import com.glxp.mipsdl.service.auth.AuthWarehouseService;
import com.glxp.mipsdl.service.thrsys.ThrCorpService;
import com.glxp.mipsdl.service.thrsys.ThrSystemDetailService;
import com.glxp.mipsdl.util.DateUtil;
import com.glxp.mipsdl.util.DictUtl;
import com.glxp.mipsdl.util.ResultVOUtils;
import com.glxp.mipsdl.util.SubmitOrderUtil;
import lombok.extern.slf4j.Slf4j;
import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.DocumentHelper;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 龙海中医院物资系统对接接口实现
 */
@Slf4j
@Service(value = "100016HttpClient") //bean注册名称，使用编码 + HttpClient，文件接口加 FileClient
public class LhzyyClient extends CommonHttpClient {



    @Resource
    private ThrSystemDetailService thrSystemDetailService;
    @Resource
    private HttpClient httpClient;
    @Resource
    private ThrBustypeOriginDao thrBustypeOriginDao;
    @Resource
    private IoOrderDao orderDao;
    @Resource
    private ThrSystemBusApiDao thrSystemBusApiDao;
    @Resource
    private BasicBussinessTypeDao basicBussinessTypeDao;
    @Resource
    private BasicCorpDao basicCorpDao;
    @Resource
    private IoCodeDao codeDao;
    @Resource
    private AuthWarehouseDao authWarehouseDao;
    @Resource
    private ThrInvWarehouseDao thrInvWarehouseDao;
    @Resource
    private AuthWarehouseService authWarehouseService;
    @Resource
    private ThirdSysConfig thirdSysConfig;
    @Resource
    private ThrCorpService thrCorpService;
    @Resource
    private IoOrderDetailBizDao orderDetailBizDao;
    @Resource
    private SubmitOrderUtil submitOrderUtil;
    @Resource
    private ThrProductsDao thrProductsDao;
    @Resource
    private BasicUdirelDao basicUdirelDao;

    @Override
    public BaseResponse getUnit(UdiwmsUnitRequest udiwmsUnitRequest) {
        LhUnitRequest lhUnitRequest = new LhUnitRequest();
        BeanUtil.copyProperties(udiwmsUnitRequest, lhUnitRequest);
        String response = httpClient.postJson(thrSystemDetailService.getUrl(Constants.URL_NAME_CORP_URL), lhUnitRequest);
        BaseResponse baseResponse = JSONObject.parseObject(response, BaseResponse.class);
        return baseResponse;
    }

    @Override
    public BaseResponse getProducts(UdiwmsProductRequest udiwmsProductRequest) {
        LhProductRequest lhProductRequest = new LhProductRequest();
        BeanUtil.copyProperties(udiwmsProductRequest, lhProductRequest);
        String response = httpClient.postJson(thrSystemDetailService.getUrl(Constants.URL_NAME_PI_QUERY_URL), lhProductRequest);
        BaseResponse baseResponse = JSONObject.parseObject(response, BaseResponse.class);
        return baseResponse;
    }

    @Override
    public BaseResponse getWarehouse(UdiwmsWarehouseRequest udiwmsWarehouseRequest) {
        String response = httpClient.postJson(thrSystemDetailService.getUrl(Constants.URL_NAME_WAREHOUSE_QUERY_URL), udiwmsWarehouseRequest);
        BaseResponse baseResponse = JSONObject.parseObject(response, BaseResponse.class);
        return baseResponse;
    }

    @Override
    public BaseResponse getOrderTypes(UdiwmsBusTypeRequest udiwmsBusTypeRequest) {
        return null;
    }

    @Override
    public BaseResponse getOrders(UdiwmsOrderQueryRequest udiwmsOrderQueryRequest) {
        return null;
    }

    @Override
    public BaseResponse submitOrders(UdiwmsOrderRequest udiwmsOrderRequest) {
        if (StrUtil.isBlank(udiwmsOrderRequest.getBillNo())) {
            return ResultVOUtils.error(500, "单据号不能为空");
        }

        DsOrderRequest dsOrderRequest = new DsOrderRequest();
        BeanUtil.copyProperties(udiwmsOrderRequest, dsOrderRequest);

        //查询单据和详情信息，组装第三方系统接口参数
        IoOrderEntity orderEntity = orderDao.selectOne(new LambdaQueryWrapper<IoOrderEntity>().eq(IoOrderEntity::getBillNo, udiwmsOrderRequest.getBillNo()).last("limit 1"));
        dsOrderRequest.setBillDate(DateUtil.formatDateTime(orderEntity.getCreateTime()));
        //查询对应的第三方单据类型
        ThrSystemBusApiEntity thrSystemBusApiEntity = thrSystemBusApiDao.selectOne(new LambdaQueryWrapper<ThrSystemBusApiEntity>().eq(ThrSystemBusApiEntity::getCode, udiwmsOrderRequest.getBillType()).last("limit 1"));
        if (StrUtil.isBlank(thrSystemBusApiEntity.getUrl())) {
            return ResultVOUtils.error(500, "接口未配置，无法提交！");
        }
        dsOrderRequest.setBillType(thrSystemBusApiEntity.getThirdBuyCode());

        //查询单据类型，设置往来单位信息
        BasicBussinessTypeEntity basicBussinessTypeEntity = basicBussinessTypeDao.selectByAction(udiwmsOrderRequest.getBillType());
        if (basicBussinessTypeEntity.getCorpType().equals(Constants.CORP_HOSPTIAL)) {
            //医院客户
            dsOrderRequest.setCorpId(orderEntity.getFromCorp());
            //查询客户名称
            String corpName = basicCorpDao.selectNameByErpId(orderEntity.getFromCorp());
            dsOrderRequest.setCorpName(corpName);
        } else if (basicBussinessTypeEntity.getCorpType().equals(Constants.CORP_INTTERNAL)) {
            //内部科室
            BasicCorpEntity basicCorpEntity = null;
            if (StrUtil.isNotEmpty(orderEntity.getFromCorp())) {
                basicCorpEntity = basicCorpDao.selectByErpId(orderEntity.getFromCorp());
            }
            if (basicCorpEntity != null) {
                dsOrderRequest.setCorpId(basicCorpEntity.getThirdId());
                dsOrderRequest.setCorpName(basicCorpEntity.getName());
            } else{
                AuthWarehouseEntity warehouseEntity = authWarehouseDao.selectOne(new LambdaQueryWrapper<AuthWarehouseEntity>().eq(AuthWarehouseEntity::getCode, udiwmsOrderRequest.getCorpId()));
                try {
                    //根据第三方系统标识，获取对应字段的值
                    ThrInvWarehouseEntity thrInvWarehouseEntity = thrInvWarehouseDao.selectOne(new LambdaQueryWrapper<ThrInvWarehouseEntity>()
                            .eq(ThrInvWarehouseEntity::getCode, authWarehouseService.getThirdInvCode(warehouseEntity))
                            .eq(ThrInvWarehouseEntity::getThirdSysFk, thirdSysConfig.getThirdId()));

                    dsOrderRequest.setCorpId(thrInvWarehouseEntity.getCode());
                    dsOrderRequest.setCorpName(thrInvWarehouseEntity.getName());
                } catch (Exception e) {
                    log.error("查询单据对应往来单位的第三方仓库信息异常", e);
                }
            }
        } else if (basicBussinessTypeEntity.getCorpType().equals(Constants.CORP_SP)) {
            //供应商
            ThrCorpEntity thrCorp = thrCorpService.getThrCorp(orderEntity.getFromCorp());
            log.error("第三方系统{}", thrCorp);
            if (null != thrCorp) {
                dsOrderRequest.setCorpId(thrCorp.getUnitId());
                dsOrderRequest.setCorpName(thrCorp.getName());
            } else {
                log.error("查询单据对应的第三方往来单位信息异常");
            }
        }

        //查询仓库信息
        AuthWarehouseEntity warehouseEntity = authWarehouseDao.selectOne(new LambdaQueryWrapper<AuthWarehouseEntity>().eq(AuthWarehouseEntity::getCode, orderEntity.getInvCode()));
        try {
            ThrInvWarehouseEntity thrInvWarehouseEntity = thrInvWarehouseDao.selectOne(new LambdaQueryWrapper<ThrInvWarehouseEntity>()
                    .eq(ThrInvWarehouseEntity::getCode, authWarehouseService.getThirdInvCode(warehouseEntity))
                    .eq(ThrInvWarehouseEntity::getThirdSysFk, thirdSysConfig.getThirdId()));

            dsOrderRequest.setLocInvCode(thrInvWarehouseEntity.getCode());
            dsOrderRequest.setLocInvName(thrInvWarehouseEntity.getName());

//            dsOrderRequest.setLocStorageCode(thrInvWarehouseEntity.getCode());
//            dsOrderRequest.setLocStorageName(thrInvWarehouseEntity.getName());
        } catch (Exception e) {
            log.info("查询第三方系统仓库信息异常", e);
        }

        if (StrUtil.nullToEmpty(thrSystemBusApiEntity.getUrl()).equals("useOut")) {
            dsOrderRequest.setCorpId(dsOrderRequest.getLocStorageCode());
            dsOrderRequest.setCorpName(dsOrderRequest.getLocStorageName());

            ThrInvWarehouseEntity thrInvWarehouseEntity = thrInvWarehouseDao.selectOne(new LambdaQueryWrapper<ThrInvWarehouseEntity>().eq(ThrInvWarehouseEntity::getCode, "29")
                    .eq(ThrInvWarehouseEntity::getThirdSysFk, thirdSysConfig.getThirdId()));
            dsOrderRequest.setLocStorageCode("29");
            dsOrderRequest.setLocStorageName(thrInvWarehouseEntity.getName());

            udiwmsOrderRequest.setLocInvCode("29");
            udiwmsOrderRequest.setLocInvName(thrInvWarehouseEntity.getName());
        }

        dsOrderRequest.setBillFlag("1");
        //设置单据出入库类型
        if (basicBussinessTypeEntity.getMainAction().equals(ConstantType.TYPE_PUT)) {
            dsOrderRequest.setInoutType(1); //入库
        } else if (basicBussinessTypeEntity.getMainAction().equals(ConstantType.TYPE_OUT)) {
            dsOrderRequest.setInoutType(2); //出库
        }

        dsOrderRequest.setRemark("udi管理系统提交单据");

        //组装单据明细数据
        List<IoCodeEntity> ioCodeEntities = codeDao.selectList(new LambdaQueryWrapper<IoCodeEntity>()
                .eq(IoCodeEntity::getOrderId, orderEntity.getBillNo())
        );

        List<UdiwmsOrderDetailRequest> items = new ArrayList<>();
        //查询业务单据详情
        List<IoOrderDetailBizEntity> detailBizEntities = orderDetailBizDao.selectList(new LambdaQueryWrapper<IoOrderDetailBizEntity>().eq(IoOrderDetailBizEntity::getOrderIdFk, orderEntity.getBillNo()));


        setOrderDetailList(ioCodeEntities, items, detailBizEntities);

        Collections.reverse(items);
        //云霄使用items字段，其他医院使用item字段
        dsOrderRequest.setItems(items);

        return submitOrderUtil.submitOrder(orderEntity, dsOrderRequest);
    }

    private void setOrderDetailList(List<IoCodeEntity> ioCodeEntities, List<UdiwmsOrderDetailRequest> orderDetailRequests, List<IoOrderDetailBizEntity> detailBizEntities) {
        for (IoOrderDetailBizEntity detailBizEntity : detailBizEntities) {
            UdiwmsOrderDetailRequest item = submitOrderUtil.buildProductInfo(detailBizEntity);
            if (StrUtil.isEmpty(item.getRegisterNo())
                    || item.getRegisterNo().contains(";")
                    || item.getRegisterNo().contains(",")
                    || item.getRegisterNo().contains("，")) {
                BasicUdirelEntity basicUdirel = basicUdirelDao.selectById(detailBizEntity.getBindRlFk());
                ThrProductsEntity thrProductsEntity = thrProductsDao.selectOne(new LambdaQueryWrapper<ThrProductsEntity>()
                        .eq(ThrProductsEntity::getCode, basicUdirel.getThirdId()).last("limit 1"));
                item.setRegisterNo(thrProductsEntity.getRegisterNo());
            }
            if (StrUtil.isNotBlank(detailBizEntity.getSecSalesInvNo())) {
                item.setSecSalesInvNo(detailBizEntity.getSecSalesInvNo());
            } else {
                item.setSecSalesInvNo("");
            }
            if (StrUtil.isNotBlank(detailBizEntity.getInvoiceDate())) {
                item.setInvoiceDate(detailBizEntity.getInvoiceDate());
            } else {
                item.setInvoiceDate("");
            }
            if (StrUtil.isNotBlank(detailBizEntity.getSecSalesListNo())) {
                item.setSecSalesListNo(detailBizEntity.getSecSalesListNo());
            } else {
                item.setSecSalesListNo("");
            }
            if (StrUtil.isNotBlank(detailBizEntity.getFirstSalesInvNo())) {
                item.setFirstSalesInvNo(detailBizEntity.getFirstSalesInvNo());
            } else {
                item.setFirstSalesInvNo("");
            }

            String fphm = "";
            String fprq = null;
            List<IoOrderInvoiceEntity> invoiceList = IoOrderInvoiceEntity.builder().build()
                    .selectList(Wrappers.lambdaQuery(IoOrderInvoiceEntity.class).eq(IoOrderInvoiceEntity::getOrderIdFk, detailBizEntity.getOrderIdFk())
                            .eq(IoOrderInvoiceEntity::getBindRlFk, detailBizEntity.getBindRlFk())
                            .eq(StrUtil.isNotEmpty(item.getBatchNo()), IoOrderInvoiceEntity::getBatchNo, item.getBatchNo()).
                            groupBy(IoOrderInvoiceEntity::getInvoiceEncode));
            if (CollectionUtil.isNotEmpty(invoiceList)) {
                fphm = invoiceList.stream().map(IoOrderInvoiceEntity::getInvoiceEncode).collect(Collectors.joining(","));
                if (invoiceList.get(0).getInvoiceDate() != null)
                    fprq = DateUtil.formatDateTime(invoiceList.get(0).getInvoiceDate());
            }
            item.setFirstSalesInvNo(fphm);
            item.setSecSalesInvNo(fphm);
            item.setInvoiceDate(fprq);
            //封装条码信息
            submitOrderUtil.setCodeList(ioCodeEntities, detailBizEntity, item);
            orderDetailRequests.add(item);
        }
    }

    @Override
    public BaseResponse getInvProducts(UdiwmsInvProductsRequest udiwmsInvProductsRequest) {
        return null;
    }


    @Override
    public BaseResponse postProducts(PostThrProductsRequest postThrProductsRequest) {
        return null;
    }

    @Override
    public BaseResponse postCorps(PostThrCorpRequest postThrCorpRequest) {
        return null;
    }

    @Override
    public BaseResponse postOrderDetail(PostFileThrOrderRequest postFileThrOrderRequest) {
        return null;
    }

    @Override
    public BaseResponse postInvProducts(PostThrInvProductsRequest postThrInvProductsRequest) {
        return null;
    }

    @Override
    public BaseResponse testConnect() {
        UdiwmsUnitRequest udiwmsUnitRequest = new UdiwmsUnitRequest();
        udiwmsUnitRequest.setPage(1);
        udiwmsUnitRequest.setLimit(1);
        BaseResponse baseResponse = getUnit(udiwmsUnitRequest);
        if (baseResponse.getCode() == 20000) {
            return ResultVOUtils.success("连接成功");
        }
        return ResultVOUtils.error(500, "连接失败！");
    }

    @Override
    public BaseResponse queryUdiInvProducts(UdiwmsQueryUdiInvProductsRequest queryUdiInvProductsRequest) {
        return null;
    }

    @Override
    public BaseResponse submitProducts(UdiwmsAddProductsRequest udiwmsAddProductsRequest) {
        return null;
    }

    @Override
    public BaseResponse submitUnit(UdiwmsAddUnitRequest udiwmsAddUnitRequest) {
        return null;
    }

    @Override
    public BaseResponse submitPreInOrders(UdiwmsPreInOrderRequest udiwmsPreInOrderRequest) {
        return null;
    }

    @Override
    public BaseResponse postRelProduct(PostRelProductRequest postThrInvProductsRequest) {
        UdiRelevanceResponse udiRelevanceResponse = postThrInvProductsRequest.getUdiRelevanceResponse();

        if (udiRelevanceResponse == null) {
            return ResultVOUtils.error(500, "提交产品列表不能为空！");
        }
        MaterialDictEntity materialDictEntity = new MaterialDictEntity();
        materialDictEntity.setYpspm(udiRelevanceResponse.getCpmctymc());
        if (StrUtil.isNotEmpty(udiRelevanceResponse.getMainId()) && udiRelevanceResponse.getMainId().endsWith("x")) {
            materialDictEntity.setMaterialCode(null);
        } else {
            materialDictEntity.setMaterialCode(udiRelevanceResponse.getNameCode());
        }

        materialDictEntity.setDlid(Integer.valueOf(udiRelevanceResponse.getBasicPrductRemak6()));
        materialDictEntity.setFlid(Integer.valueOf(udiRelevanceResponse.getBasicPrductRemak1()));
        materialDictEntity.setXlid(Integer.valueOf(udiRelevanceResponse.getBasicPrductRemak2()));
        materialDictEntity.setCd(Integer.valueOf(udiRelevanceResponse.getBasicPrductRemak3()));
        materialDictEntity.setGg(udiRelevanceResponse.getBasicPrductRemak4());
        materialDictEntity.setXh(udiRelevanceResponse.getBasicPrductRemak5());
        materialDictEntity.setDw(1);
        materialDictEntity.setDw1(Integer.valueOf(udiRelevanceResponse.getBasicPrductRemak7()));
        BigDecimal bigDecimal1 = new BigDecimal(udiRelevanceResponse.getBasicPrductRemak8());
        BigDecimal scaledValue1 = bigDecimal1.setScale(3, BigDecimal.ROUND_HALF_UP);
        materialDictEntity.setHsgx(scaledValue1);
        materialDictEntity.setYbbm(udiRelevanceResponse.getYbbm());
        materialDictEntity.setGjhcbm(udiRelevanceResponse.getYbbm());
        BigDecimal bigDecimal = new BigDecimal(udiRelevanceResponse.getBasicPrductRemak10());
        BigDecimal scaledValue = bigDecimal.setScale(3, BigDecimal.ROUND_HALF_UP);

        materialDictEntity.setLsj(scaledValue);
        materialDictEntity.setPfj(scaledValue);
        materialDictEntity.setPzwh(udiRelevanceResponse.getZczbhhzbapzbh());
        materialDictEntity.setGhdw(Integer.valueOf(udiRelevanceResponse.getBasicPrductRemak9()));
        materialDictEntity.setHealthcode(udiRelevanceResponse.getBasicPrductRemak11());
        materialDictEntity.setYbjsqr(udiRelevanceResponse.getBasicPrductRemak12());
        if (udiRelevanceResponse.getIsStack()){
            materialDictEntity.setSfzht(1);
        }else {
            materialDictEntity.setSfzht(0);
        }
        materialDictEntity.setSfybfw(Integer.valueOf(udiRelevanceResponse.getBasicPrductRemak13()));


        String response = httpClient.postJson(thrSystemDetailService.getUrlExclude(Constants.URL_NAME_PRODUCT_SUBMIT_URL), materialDictEntity);
        log.error("提交新增产品信息返回：" + response);
//        String third = String.valueOf(response.getData());
//        try {
//            log.error("提交新增产品信息：" + materialDictEntity);
//            BaseResponse baseResponse = JSONObject.parseObject(response, BaseResponse.class);
////            LhBaseResponse baseResponse = JSONObject.parseObject(response, LhBaseResponse.class);
//            if (baseResponse.getCode() != 20000) {
//                String errMsg = "提交新增产品信息，异常：{}" + response;
//                log.error(errMsg);
//                return ResultVOUtils.error(500, "提交新增产品失败！");
//
//            } else {
////                materialDictEntity.setMaterialNo(baseResponse.getMaterialNo());
//                log.error("提交新增产品信息，成功：{}", response);
//                return ResultVOUtils.success();
//            }
//        } catch (Exception e) {
//            String errMsg = "提交新增产品信息，异常：{}" + response;
//            log.error(errMsg);
//            log.error("异常信息：{}", e);
//            return ResultVOUtils.error(500, errMsg);
//
//        }
        return null;
    }

}
