package com.glxp.mipsdl.controller;

import cn.hutool.core.util.StrUtil;
import com.glxp.mipsdl.client.ClientProcessor;
import com.glxp.mipsdl.req.base.UdiwmsQueryUdiInvProductsRequest;
import com.glxp.mipsdl.req.drugMachine.PutGoodsA001Request;
import com.glxp.mipsdl.req.drugMachine.PutGoodsB001Request;
import com.glxp.mipsdl.req.drugMachine.SendGoodsB002Request;
import com.glxp.mipsdl.res.BaseResponse;
import com.glxp.mipsdl.util.ResultVOUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

@Slf4j
@RestController
public class DrugMachineController {


    /**
     * A001
     * 发药机上货接口1
     * 发药机提供接收接口，接收药械追溯管理系统的上货信息
     * @param putGoodsA001Request
     * @return
     */
    @PostMapping("/drugMachine/putGoods/A001")
    public BaseResponse putGoodsA001(@RequestBody PutGoodsA001Request putGoodsA001Request) {
        return ClientProcessor.getHttpClient().putGoodsA001(putGoodsA001Request);
    }


    /**
     * B001
     * 发药机上货接口2
     * 药械追溯管理系统提供接收接口，接收发药机上货信息
     * @param putGoodsB001Request
     * @return
     */
    @PostMapping("/drugMachine/putGoods/B001")
    public BaseResponse putGoodsB001(@RequestBody PutGoodsB001Request putGoodsB001Request) {

        return ClientProcessor.getHttpClient().putGoodsB001(putGoodsB001Request);

    }


    /**
     * B002
     * 发药机发药接口
     * 药械追溯管理系统提供接收接口，接收发药机发药信息
     * @param sendGoodsB002Request
     * @return
     */
    @PostMapping("/drugMachine/sendGoods/B002")
    public BaseResponse sendGoodsB002(@RequestBody SendGoodsB002Request sendGoodsB002Request) {

        return ClientProcessor.getHttpClient().sendGoodsB002(sendGoodsB002Request);

    }
}
